/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package feux.exo2Et3;

import feux.exo1.*;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.EventHandler;
import javax.swing.JPanel;

/**
 *
 * @author rosmord
 */
public class JFeu2 extends JPanel {

    private int marge = 10;
    private int diametre = 100;
    private FeuModele modele;

    /**
     * De l'audace
     */
    private FeuListener listener = new FeuListener() {

        @Override
        public void feuModifie() {
            repaint();
        }
    };

    public JFeu2() {
        this(new FeuModele());
    }

    public JFeu2(FeuModele modele) {
        setModele(modele);
        setBackground(Color.BLACK);
        addMouseListener(new MyMouseListener());
    }

    @Override
    public Dimension getPreferredSize() {
        return getMeilleureDimension(diametre);
    }

    private Dimension getMeilleureDimension(int diametre) {
        return new Dimension(diametre + 2 * marge, 4 * marge + 3 * diametre);
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);

        int posx = marge;
        int posy = marge;

        for (CouleurFeu couleur : new CouleurFeu[]{CouleurFeu.ROUGE, CouleurFeu.ORANGE, CouleurFeu.VERT}) {
            if (couleur == modele.getCouleurFeu()) {
                g.setColor(couleur.getColor());
            } else {
                g.setColor(Color.GRAY);
            }
            g.fillOval(posx, posy, diametre, diametre);
            posy += diametre + marge;

        }
// Vieux code que je laisse ici à titre de comparaison.
// En utilisant une boucle, on réduit les copiers/coller,
// et on rend le code plus intelligent et plus sûr.
// J'ai laissé le code dans un état où j'avais un bug dû à un copier/coller
// (c'est MAL, le copier/coller).
//        Color feuRouge = Color.GRAY;
//        Color feuOrange = Color.GRAY;
//        Color feuVert = Color.GRAY;
//
//        switch (modele.getCouleurFeu()) {
//            case ROUGE:
//                feuRouge = Color.RED;
//                break;
//            case VERT:
//                feuVert = Color.GREEN;
//                break;
//            case ORANGE:
//                feuVert = Color.GREEN;
//                break;
//        }
//
//        
//        g.setColor(feuOrange);
//        g.fillOval(posx, posy, diametre, diametre);
//        g.setColor(feuVert);
//        posy += diametre + marge;
//        g.fillOval(posx, posy, diametre, diametre);
    }

    public CouleurFeu getCouleurFeuPourPosition(Point point) {
        if (point.getY() < marge+ diametre) {
            return CouleurFeu.ROUGE;
        } else if (point.getY() < 2* marge+ 2 * diametre) {
            return CouleurFeu.ORANGE;
        } else {
            return CouleurFeu.VERT;
        }
    }

    public void setModele(FeuModele modele) {
        if (this.modele != null) {
            this.modele.removeFeuListener(listener);
        }
        this.modele = modele;
        modele.addFeuListener(listener);
    }

    private class MyMouseListener extends MouseAdapter {

        @Override
        public void mouseClicked(MouseEvent e) {
            CouleurFeu col = getCouleurFeuPourPosition(e.getPoint());
            modele.setCouleurFeu(col);
        }

    }

}
